# Microeconometrics
# CLASS 1b
# Continous variables
# Wiktor Budzinski, Marek Giergiczny

library(gamlss)

rm(list=ls())
setwd("C:\\Users\\budzi\\Documents\\ME QPE\\2023\\Class 1") 
load("Class1.RData")

Eq7 <- LogPrice ~ LogCases + LogCases:washington + LogCases:Nonvarietal + LogCases:Pinotnoir + LogCases:Cabernet + LogCases:Merlot + LogCases:Shyrah +
  Score + ScoreSq + Score:washington + Score:Nonvarietal + Score:Pinotnoir + Score:Cabernet + Score:Merlot + Score:Shyrah +
  Age + Age:washington + Age:Nonvarietal + Age:Pinotnoir + Age:Cabernet + Age:Merlot + Age:Shyrah +
  NapaValley+BayArea+sonoma+SouthCoast+carneros+Sierra+mendocino + washington +
  Nonvarietal + Pinotnoir + Cabernet + Merlot + Shyrah + Reserve + Vineyard + Estate +
  Vintage91 + Vintage92 + Vintage93 + Vintage94 + Vintage95 + Vintage96  + Vintage97 + Vintage98 + Vintage99
model7 <- lm(Eq7, data=data)
summ(model7, digits = 4)

################################################# Exercise 4 ########################################
# Box Cox

Eq7b <- Price ~ LogCases + LogCases:washington + LogCases:Nonvarietal + LogCases:Pinotnoir + LogCases:Cabernet + LogCases:Merlot + LogCases:Shyrah +
  Score + ScoreSq + Score:washington + Score:Nonvarietal + Score:Pinotnoir + Score:Cabernet + Score:Merlot + Score:Shyrah +
  Age + Age:washington + Age:Nonvarietal + Age:Pinotnoir + Age:Cabernet + Age:Merlot + Age:Shyrah +
  NapaValley+BayArea+sonoma+SouthCoast+carneros+Sierra+mendocino + washington +
  Nonvarietal + Pinotnoir + Cabernet + Merlot + Shyrah + Reserve + Vineyard + Estate +
  Vintage91 + Vintage92 + Vintage93 + Vintage94 + Vintage95 + Vintage96  + Vintage97 + Vintage98 + Vintage99
model7b <- lm(Eq7b, data=data)

# fitting models with various Box-Cox transformations
bx<-MASS::boxcox(model7b, lambda=seq(-2, 2, length=200), data=data)
XVal<-bx[["x"]]
XVal[which(bx[["y"]] == max(bx[["y"]]))]

data$PriceBC <- (data$Price^(-0.23)-1)/0.23
Eq7c <- PriceBC ~ LogCases + LogCases:washington + LogCases:Nonvarietal + LogCases:Pinotnoir + LogCases:Cabernet + LogCases:Merlot + LogCases:Shyrah +
  Score + ScoreSq + Score:washington + Score:Nonvarietal + Score:Pinotnoir + Score:Cabernet + Score:Merlot + Score:Shyrah +
  Age + Age:washington + Age:Nonvarietal + Age:Pinotnoir + Age:Cabernet + Age:Merlot + Age:Shyrah +
  NapaValley+BayArea+sonoma+SouthCoast+carneros+Sierra+mendocino + washington +
  Nonvarietal + Pinotnoir + Cabernet + Merlot + Shyrah + Reserve + Vineyard + Estate +
  Vintage91 + Vintage92 + Vintage93 + Vintage94 + Vintage95 + Vintage96  + Vintage97 + Vintage98 + Vintage99

model7c <- lm(Eq7c, data=data)
summary(model7c)
resettest(model7c)
stargazer(model7, model7c, type="text", df=FALSE)  

# BOX COX using gamlss
model7cc <- gamlss(Eq7b, sigma.formula = ~1, nu.formula = ~1, family = BCCG(), data = data)
summary(model7cc)

# Box cox for independent variable (nonlinear least squares)

Eq7d <- LogPrice ~ LogCases + Score + ScoreSq + Age
model7d <- lm(Eq7d, data = data)
coef(model7d)
Eq7e <- LogPrice ~ b1+ b2*I((Cases^a1-1)/a1)
model7e <- nls(Eq7e, data = data, start = list(a1 = -0.01, b1 = 22, b2 = -0.1))
summary(model7e)

Eq7e <- LogPrice ~ b1+ b2*I((Cases^a1-1)/a1) + b3*Score+ b4*Age
model7f <- nls(Eq7e, data = data, start = list(a1 = 0.1,  b1 = 3.6, b2 = -0.1, b3 = -0.5, b4 = 0.15))
summary(model7f)

# Splines

# Natural cubic splines
Eq8 <- LogPrice ~ ns(Cases, df=5) + LogCases:washington + LogCases:Nonvarietal + LogCases:Pinotnoir + LogCases:Cabernet + LogCases:Merlot + LogCases:Shyrah +
  ns(Score, df = 5) + Score:washington + Score:Nonvarietal + Score:Pinotnoir + Score:Cabernet + Score:Merlot + Score:Shyrah +
  Age + Age:washington + Age:Nonvarietal + Age:Pinotnoir + Age:Cabernet + Age:Merlot + Age:Shyrah +
  NapaValley+BayArea+sonoma+SouthCoast+carneros+Sierra+mendocino + washington +
  Nonvarietal + Pinotnoir + Cabernet + Merlot + Shyrah + Reserve + Vineyard + Estate +
  Vintage91 + Vintage92 + Vintage93 + Vintage94 + Vintage95 + Vintage96  + Vintage97 + Vintage98 + Vintage99  
model8 <- lm(Eq8, data=data)
summ(model8)
summ(model7)
resettest(model8)
data$Spline1 <- model8$model$`ns(Cases, df = 5)` %*% model8$coefficients[c(2, 3, 4, 5, 6)]
plot(data$Cases, data$Spline1)
points(data$Cases, -0.10*data$LogCases, col="red")

data$Spline2 <- model8$model$`ns(Score, df = 5)` %*% model8$coefficients[c(7, 8, 9, 10, 11)]
plot(data$Score, data$Spline2)
points(data$Score, -0.423*data$Score + 0.268*data$ScoreSq+16.5, col="red")

# B-spline

Eq9 <- LogPrice ~ bs(Cases, df=5) + LogCases:washington + LogCases:Nonvarietal + LogCases:Pinotnoir + LogCases:Cabernet + LogCases:Merlot + LogCases:Shyrah +
  bs(Score, df = 5) + Score:washington + Score:Nonvarietal + Score:Pinotnoir + Score:Cabernet + Score:Merlot + Score:Shyrah +
  Age + Age:washington + Age:Nonvarietal + Age:Pinotnoir + Age:Cabernet + Age:Merlot + Age:Shyrah +
  NapaValley+BayArea+sonoma+SouthCoast+carneros+Sierra+mendocino + washington +
  Nonvarietal + Pinotnoir + Cabernet + Merlot + Shyrah + Reserve + Vineyard + Estate +
  Vintage91 + Vintage92 + Vintage93 + Vintage94 + Vintage95 + Vintage96  + Vintage97 + Vintage98 + Vintage99  

model9 <- lm(Eq9, data=data)
summ(model9, digits = 4)
resettest(model9)

data$Spline1b <- model9$model$`bs(Cases, df = 5)` %*% model9$coefficients[c(2, 3, 4, 5, 6)]
plot(data$Cases, data$Spline1b)
points(data$Cases, -0.10*data$LogCases, col="red")


data$Spline2b <- model9$model$`bs(Score, df = 5)` %*% model9$coefficients[c(7, 8, 9, 10, 11)]
plot(data$Score, data$Spline2b)


# Smoothing spline
  # Be default: Thin plate regression splines
Eq10 <- LogPrice ~ s(Cases) + LogCases:washington + LogCases:Nonvarietal + LogCases:Pinotnoir + LogCases:Cabernet + LogCases:Merlot + LogCases:Shyrah +
  s(Score) + Score:washington + Score:Nonvarietal + Score:Pinotnoir + Score:Cabernet + Score:Merlot + Score:Shyrah +
  Age + Age:washington + Age:Nonvarietal + Age:Pinotnoir + Age:Cabernet + Age:Merlot + Age:Shyrah +
  NapaValley+BayArea+sonoma+SouthCoast+carneros+Sierra+mendocino + washington +
  Nonvarietal + Pinotnoir + Cabernet + Merlot + Shyrah + Reserve + Vineyard + Estate +
  Vintage91 + Vintage92 + Vintage93 + Vintage94 + Vintage95 + Vintage96  + Vintage97 + Vintage98 + Vintage99  
model10 <- gam(Eq10, data = data)
summary(model10)
plot(model10)

# Using cubic splines instead of default
Eq10b <- LogPrice ~ s(Cases, bs = "cr") + LogCases:washington + LogCases:Nonvarietal + LogCases:Pinotnoir + LogCases:Cabernet + LogCases:Merlot + LogCases:Shyrah +
  s(Score, bs = "cr") + Score:washington + Score:Nonvarietal + Score:Pinotnoir + Score:Cabernet + Score:Merlot + Score:Shyrah +
  Age + Age:washington + Age:Nonvarietal + Age:Pinotnoir + Age:Cabernet + Age:Merlot + Age:Shyrah +
  NapaValley+BayArea+sonoma+SouthCoast+carneros+Sierra+mendocino + washington +
  Nonvarietal + Pinotnoir + Cabernet + Merlot + Shyrah + Reserve + Vineyard + Estate +
  Vintage91 + Vintage92 + Vintage93 + Vintage94 + Vintage95 + Vintage96  + Vintage97 + Vintage98 + Vintage99  
model10b <- gam(Eq10b, data = data)
summary(model10b)
plot(model10b)

################################################# Exercise 5 ########################################
# Heteroskedascity 

summ(model7, digits = 4)
summ(model7, digits = 4, robust = "HC0") # Robuts covariance matrix

# Regular regression
model11a <- gamlss(Eq7, sigma.formula = ~ 1, family = NO(), data = data)
summary(model11a)

## Modelling heteroskedasticity
Eq7b <- ~LogCases + Score + ScoreSq + Age +
  NapaValley+BayArea+sonoma+SouthCoast+carneros+Sierra+mendocino + washington +
  Nonvarietal + Pinotnoir + Cabernet + Merlot + Shyrah + Reserve + Vineyard + Estate +
  Vintage91 + Vintage92 + Vintage93 + Vintage94 + Vintage95 + Vintage96  + Vintage97 + Vintage98 + Vintage99

model11b <- gamlss(Eq7, sigma.formula = ~LogCases + Score + ScoreSq + Age +
                     NapaValley+BayArea+sonoma+SouthCoast+carneros+Sierra+mendocino + washington +
                     Nonvarietal + Pinotnoir + Cabernet + Merlot + Shyrah + Reserve + Vineyard + Estate +
                     Vintage91 + Vintage92 + Vintage93 + Vintage94 + Vintage95 + Vintage96  + Vintage97 + Vintage98 + Vintage99, 
                   family = NO(), data = data)

summary(model11b)
LR.test(model11a, model11b, print = TRUE)